(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .constant('cmlMedicationTemplates', [
            {
                langKey: 'MEDICATION-TEMPLATE-IMATINIB',
                name: 'imatinib',
                template: {
                    interval: 'day',
                    doses: 1,
                    unit: 'milligrams',
                    amount: 400
                }
            },
            {
                langKey: 'MEDICATION-TEMPLATE-DASATINIB',
                name: 'dasatinib',
                template: {
                    interval: 'day',
                    doses: 1,
                    unit: 'milligrams',
                    amount: 100
                }
            },
            {
                langKey: 'MEDICATION-TEMPLATE-NILOTINIB',
                name: 'nilotinib',
                template: {
                    interval: 'day',
                    doses: 2,
                    unit: 'milligrams',
                    amount: 300
                }
            },
            {
                langKey: 'MEDICATION-TEMPLATE-BOSUTINIB',
                name: 'bosutinib',
                template: {
                    interval: 'day',
                    doses: 1,
                    unit: 'milligrams',
                    amount: 500
                }
            },
            {
                langKey: 'MEDICATION-TEMPLATE-PONATINIB',
                name: 'ponatinib',
                template: {
                    interval: 'day',
                    doses: 1,
                    unit: 'milligrams',
                    amount: 45
                }
            },
            {
                langKey: 'MEDICATION-TEMPLATE-INTERFERON_ALFA',
                name: 'interferon_alfa',
                template: {
                    interval: 'week',
                    doses: 1,
                    unit: 'micrograms',
                    amount: 30
                }
            },
            {
                langKey: 'MEDICATION-TEMPLATE-OTHER',
                name: 'other',
                template: {
                    interval: 'day',
                    doses: 1,
                    unit: 'tablets',
                    amount: 1
                }
            }
        ]);
})();