(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .controller('cmlAdherenceMedicationDetailController', cmlAdherenceMedicationDetailController);

    function cmlAdherenceMedicationDetailController($scope, $stateParams, $log, cmlMedicationsService, cmlAdherenceService, _, $translate) {
        $log.debug('Hello cmlAdherenceMedicationDetailController');


        $scope.date = new Date(parseInt($stateParams['date']));
        $scope.medication = cmlMedicationsService.get($stateParams['id']);
        $scope.doses = [];

        $scope.dateFormat = $translate.instant('TAB-REMINDER-DATE-FORMAT');
        $scope.timeFormat = $translate.instant('TAB-REMINDER-TIME-FORMAT');

        reload();

        function reload() {
            if ($scope.medication.interval == 'day') {
                $scope.doses = $scope.medication.doses;
            } else {
                var weekDay = $scope.date.getDay();
                _.each($scope.medication.doses, function (dose) {
                    if (dose.weekDay == weekDay) {
                        $scope.doses.push(dose);
                    }
                });
            }
        }

        $scope.isTaken = function (dose) {
            return cmlAdherenceService.hasTakenDose($scope.date, $scope.medication.id, dose.id);
        };

        $scope.changeStatus = function (dose) {
            if (!$scope.isTaken(dose)) {
                $log.debug('changeStatus taken:', true);
                cmlAdherenceService.addTakenDose($scope.date, $scope.medication, dose.id);
            } else {
                $log.debug('changeStatus taken:', false);
                cmlAdherenceService.removeTakenDose($scope.date, $scope.medication, dose.id);
            }
        };
    }
})();
