(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .controller('cmlAppTabsController', cmlAppTabsController);

    function cmlAppTabsController($scope, $rootScope, $state, $sce, $log, $ionicHistory, $ionicScrollDelegate, $translate) {
        $log.debug('Hello cmlAppTabsController');

        // register event to hide the tab bar if necessary
        // https://github.com/driftyco/ionic/issues/395#issuecomment-83371816
        $rootScope.$on('$stateChangeStart', function (event, toState) {
            $rootScope.tabBarHidden = toState.data && toState.data.tabBarHidden;
        });

        $scope.goTab = function (state) {
            // reset scroll position to top
            $ionicScrollDelegate.scrollTop(true);

            // clear damn routing history
            // don't forget to use hide-back-button="true" attribute on ion-view!
            $ionicHistory.clearHistory();

            $state.go(state);
        };

        $rootScope.translateHTML = function(lang_key) {
            return $sce.trustAsHtml($translate.instant(lang_key));
        };
    }
})();
