(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .controller('cmlOrganisationController', cmlOrganisationController);

    function cmlOrganisationController($scope, $http, $log, cmlOrganisationService, cmlLanguageService, cmlLanguages, cmlApiEndpoints, $ionicLoading, $cordovaDialogs, $translate) {
        $log.debug('Hello cmlOrganisationController');

        $scope.error = false;
        $scope.organisation = cmlOrganisationService.get();

        $scope.reload = function () {
            $scope.error = false;
            $scope.language = cmlLanguages[cmlLanguageService.get()];
            $scope.organisation = cmlOrganisationService.get();

            if (angular.isUndefined($scope.organisation)) {
                $scope.error = 'organisation_undefined';
            } else {
                $ionicLoading.show();

                $http({
                    method: 'GET',
                    url: cmlApiEndpoints.organisation.url($scope.organisation.name, $scope.language.key)
                }).then(function (response) {
                    cmlOrganisationService.setContent(response.data);
                    $scope.organisation = cmlOrganisationService.get();

                    $ionicLoading.hide();
                }, function () {
                    $cordovaDialogs.alert(
                        $translate.instant('TAB-ORGANISATION-ERROR'),
                        $translate.instant('TAB-ORGANISATION-ERROR-TITLE')
                    );

                    $scope.organisation = cmlOrganisationService.get();
                    $ionicLoading.hide();
                });
            }
        };

        $scope.$on('$ionicView.afterEnter', function () {
            $scope.reload();
        });
    }
})();
