(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .controller('cmlProfileController', cmlProfileController);

    function cmlProfileController($scope, $log, cmlOrganisationService, cmlLanguageService, cmlTutorialService, cmlLanguages, $translate) {
        $log.debug('Hello cmlLabResultsController');

        $scope.getUserLanguage = function () {
            return cmlLanguages[cmlLanguageService.get()];
        };

        $scope.getUserOrganisation = function () {
            return cmlOrganisationService.get();
        };

        $scope.tutorial = {
            active: false
        };

        init();

        function init() {
            $scope.tutorial.active = !cmlTutorialService.isDone();
            $scope.tab_title = $translate.instant('TAB-TITLE-PROFILE');
        }

        $scope.changeTutorial = function () {
            cmlTutorialService.setDone(!$scope.tutorial.active);
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            init();
        });
    }
})();
