(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .controller('cmlSettingsOrganisationController', cmlSettingsOrganisationController);

    function cmlSettingsOrganisationController($scope, $log, $stateParams, cmlOrganisationService, $ionicLoading) {
        $log.debug('Hello cmlSettingsOrganisationController');

        $scope.regions = cmlOrganisationService.getAll();
        $scope.userOrganisation = cmlOrganisationService.get();

        if (angular.isDefined($stateParams['region'])) {
            var _key = Object.keys($scope.regions)[$stateParams['region']];
            $scope.region = $scope.regions[_key];
        }

        $scope.reload = function () {
            $ionicLoading.show();
            cmlOrganisationService.reload().then(function () {
                $ionicLoading.hide();
            }, function () {
                $ionicLoading.hide();
                // todo: maybe show error?
            });
        };

        $scope.changeUserOrganisation = function (organisation) {
            cmlOrganisationService.set(organisation);
            $scope.userOrganisation = organisation;
        };

        $scope.isUserOrganisation = function (organisation) {
            return organisation.name === $scope.userOrganisation.name;
        };
    }
})();
