(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .directive('cmlAdherenceListItem', cmlAdherenceListItem)
        .directive('cmlAdherenceItem', cmlAdherenceItem);

    function cmlAdherenceListItem($log) {
        $log.debug('Hello cmlAdherenceListItem');

        return {
            restrict: 'E',
            template: '<div class="item" ng-transclude></div>',
            scope: {
                'taken': '=',
                'max': '='
            },
            transclude: true,
            link: function (scope, elem) {
                var _item = elem.find('div');

                function setBackground() {
                    _item.removeClass('cml-item-red')
                        .removeClass('cml-item-green')
                        .removeClass('cml-item-orange');

                    if (scope.max <= scope.taken) {
                        _item.addClass('cml-item-green');
                    } else if (scope.max > scope.taken && scope.taken !== 0) {
                        _item.addClass('cml-item-orange');
                    } else {
                        _item.addClass('cml-item-red');
                    }
                }

                scope.$watchGroup(['taken', 'max'], function () {
                    setBackground();
                });
            }
        }
    }

    function cmlAdherenceItem($log, cmlAdherenceService) {
        $log.debug('Hello cmlAdherenceItem');



        return {
            template: '<a class="item item-icon-right cml-item-icon-accessory-right" ng-href="#/tab/adherence/{{medication.id}}" ng-transclude></a>',
            scope: {
                medication: '=',
                adherence: '='
            },
            transclude: true,
            controller: function ($scope) {
            },
            link: function (scope, elem) {
                var _item = elem.find('a');

                function setBackground() {
                    _item.removeClass('cml-item-red')
                        .removeClass('cml-item-green')
                        .removeClass('cml-item-orange');

                    if (scope.adherence >= 90) {
                        _item.addClass('cml-item-green');
                    } else if (scope.adherence >= 80) {
                        _item.addClass('cml-item-orange');
                    } else {
                        _item.addClass('cml-item-red');
                    }
                }

                scope.$watch('adherence', function () {
                    setBackground();
                }, true);
            }
        };
    }
})();
