(function () {
    'use strict';

    angular
        .module('cml-adherence-app')
        .directive('cmlHtmlContent', cmlHtmlContent);

    function cmlHtmlContent($log) {
        $log.debug('Hello cmlHtmlContent');

        return {
            restrict: 'A',
            link: function (scope, elem, attrs) {
                var content;

                function updateContent() {
                    var html = content;

                    // remove inline styling
                    html = html.replace(/style="([^\"]+)"/gi, '');
                    // fix img with to max 100% and remove height
                    html = html.replace(/width="([^\"]+)"/gi, 'style="max-width:100%"');
                    html = html.replace(/height="([^\"]+)"/gi, '');
                    // fix image sources if relative url
                    html = html.replace(/src="(?!http)([^\"]+)"/gi, 'src="http://www.cmladvocates.net/$1"');
                    // open external urls in browser
                    html = html.replace(/href="([^\"]+)"/gi, 'href="$1" onClick="window.open(\'$1\', \'_system\', \'location=yes\'); return false;"');

                    elem.html(html);
                }

                scope.$watch(attrs['cmlHtmlContent'], function (val) {
                    content = val;

                    if (angular.isDefined(content))
                        updateContent();
                });
            }
        }
    }
})();
