(function () {
    'use strict';

    angular.module('cml-adherence-app')
        .factory('cmlLocalStorageService', cmlLocalStorageService);

    function cmlLocalStorageService($window, $log) {
        $log.debug('Hello cmlLocalStorageService');

        var self = this;

        self.set = function (key, value) {
            $window.localStorage[key] = value;
        };

        self.get = function (key, defaultValue) {
            return $window.localStorage[key] || defaultValue;
        };

        self.setObject = function (key, value) {
            $window.localStorage[key] = angular.toJson(value);
        };

        self.getObject = function (key) {
            return angular.fromJson($window.localStorage[key]);
        };

        self.strToDate = function (str) {
            if (typeof str === 'string') {
                return new Date(str);
            }
            return str;
        };

        return self;
    }
})();
