(function () {
    'use strict';

    angular.module('cml-adherence-app')
        .factory('cmlNotepadService', cmlNotepadService);

    function cmlNotepadService($log, cmlLocalStorageService) {
        $log.debug('Hello cmlNotepadService');

        var STORAGE_KEY = 'cml.notepad';

        var self = this;
        var _notepad;

        function serialize() {
            cmlLocalStorageService.set(STORAGE_KEY, _notepad);
        }

        function deserialize() {
            var tmp = cmlLocalStorageService.get(STORAGE_KEY);

            if (angular.isUndefined(tmp)) {
                tmp = '';
            }

            _notepad = tmp;
        }

        self.init = function () {
            deserialize();
        };

        self.set = function (text) {
            _notepad = text;
            serialize();
        };

        self.get = function () {
            deserialize();
            return _notepad;
        };

        return self;
    }
})();
