(function () {
    'use strict';

    angular.module('cml-adherence-app')
        .factory('cmlTutorialService', cmlTutorialService);

    function cmlTutorialService($log, cmlLocalStorageService, _) {
        $log.debug('Hello cmlTutorialService');

        var STORAGE_KEY = 'cml.tutorial.done';

        var self = this;
        var _done;

        function serialize() {
            cmlLocalStorageService.set(STORAGE_KEY, JSON.stringify(_done));
        }

        function deserialize() {
            var data = cmlLocalStorageService.get(STORAGE_KEY, false);

            data = data === 'true';
            $log.debug('isBool', _.isBoolean(data));

            _done = data;
        }

        self.init = function () {
            deserialize();
        };

        self.isDone = function () {
            return _done;
        };

        self.setDone = function (status) {
            _done = status;
            serialize();
        };

        return self;
    }
})();
